import logging

from kamikaze3.common.autoscaling import (
    MAGENTO2_APPLICATION_SPECIFIC_REQUIREMENTS_DOCUMENTATION_LINK,
)
from kamikaze3.event_listener.settings import PROGRAM_NAME

logger = logging.getLogger(PROGRAM_NAME)


APPLICATION_ELIGIBILITY_CHECKS = {}


def application_check(
    name,
    application,
    description,
    documentation_link=MAGENTO2_APPLICATION_SPECIFIC_REQUIREMENTS_DOCUMENTATION_LINK,
):
    def wrapper(func):
        if application not in APPLICATION_ELIGIBILITY_CHECKS:
            APPLICATION_ELIGIBILITY_CHECKS[application] = []

        APPLICATION_ELIGIBILITY_CHECKS[application].append(
            {
                "name": name,
                "description": description,
                "function": func,
                "documentation_link": documentation_link,
            }
        )

        return func

    return wrapper
